'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PlotlyTransform = undefined;

var _cloneDeep2 = require('lodash/cloneDeep');

var _cloneDeep3 = _interopRequireDefault(_cloneDeep2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Plotly = require('plotly.js/dist/plotly');
/* eslint class-methods-use-this: 0 */


const MIMETYPE = 'application/vnd.plotly.v1+json';

class PlotlyTransform extends _react2.default.Component {

  constructor() {
    super();
    this.getFigure = this.getFigure.bind(this);
  }

  componentDidMount() {
    // Handle case of either string to be `JSON.parse`d or pure object
    const figure = this.getFigure();
    Plotly.newPlot(this.el, figure.data, figure.layout);
  }

  shouldComponentUpdate(nextProps) {
    return this.props.data !== nextProps.data;
  }

  componentDidUpdate() {
    const figure = this.getFigure();
    this.el.data = figure.data;
    this.el.layout = figure.layout;
    Plotly.redraw(this.el);
  }

  getFigure() {
    const figure = this.props.data;
    if (typeof figure === 'string') {
      return JSON.parse(figure);
    }

    // The Plotly API *mutates* the figure to include a UID, which means
    // they won't take our frozen objects
    if (Object.isFrozen(figure)) {
      return (0, _cloneDeep3.default)(figure);
    }
    return figure;
  }

  render() {
    const { layout } = this.getFigure();
    const style = {};
    if (layout && layout.height && !layout.autosize) {
      style.height = layout.height;
    }
    return _react2.default.createElement('div', { style: style, ref: el => {
        this.el = el;
      } });
  }
}

exports.PlotlyTransform = PlotlyTransform;
PlotlyTransform.MIMETYPE = MIMETYPE;
exports.default = PlotlyTransform;